/*
 * Copyright (c) 2024 The Arizona Board of Regents on behalf of the University
 * of Arizona. All rights reserved.
 *
 * This file is part of Astrolabe. Astrolabe is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as  published by the Free Software Foundation, either version 3 of
 * the License, or  (at your option) any later version. Astrolabe is distributed
 * in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
 * the GNU General Public License for more details. You should have received a
 * copy of the GNU General Public License along with Astrolabe.
 * If not, see <https://www.gnu.org/licenses/>.
 */
package astrolabe.kernelcache.options;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.DefaultTableModel;
import org.openide.util.Exceptions;

final class KernelCachePanel extends javax.swing.JPanel {

    private static final Logger LOG = Logger.getLogger(KernelCachePanel.class.getName());

    private final KernelCacheOptionsPanelController controller;

    KernelCachePanel(KernelCacheOptionsPanelController controller) {
        this.controller = controller;
        initComponents();
        // TODO listen to changes in form fields and call controller.changed()
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        kernelCacheTable = new javax.swing.JTable();

        kernelCacheTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Prefix", "URL"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        kernelCacheTable.setColumnSelectionAllowed(true);
        jScrollPane1.setViewportView(kernelCacheTable);
        kernelCacheTable.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        if (kernelCacheTable.getColumnModel().getColumnCount() > 0) {
            kernelCacheTable.getColumnModel().getColumn(0).setPreferredWidth(50);
            kernelCacheTable.getColumnModel().getColumn(0).setHeaderValue(org.openide.util.NbBundle.getMessage(KernelCachePanel.class, "KernelCachePanel.kernelCacheTable.columnModel.title0")); // NOI18N
            kernelCacheTable.getColumnModel().getColumn(1).setHeaderValue(org.openide.util.NbBundle.getMessage(KernelCachePanel.class, "KernelCachePanel.kernelCacheTable.columnModel.title1")); // NOI18N
        }

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 567, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 195, Short.MAX_VALUE)
                .addGap(0, 0, 0))
        );
    }// </editor-fold>//GEN-END:initComponents

    void load() {
        LOG.log(Level.INFO, "load");

        // Make sure there's a directory called ~/.astrolabe-data.
        Path dataDir = Paths.get(System.getProperty("user.home") + "/.astrolabe-data");
        if (!dataDir.toFile().exists()) {
            dataDir.toFile().mkdirs();
        }

        // Try and get the kernel cache configuration file.
        var cfg = dataDir.resolve("kernel-cache.csv");
        if (!cfg.toFile().exists()) {
            // Kernel cache does not yet exist. Create it and populate it with the NAIF generics kernel archive.
            try (var fos = new FileOutputStream(cfg.toFile())) {
                fos.write(String.format("%s,%s\n", "NAIF", "https://naif.jpl.nasa.gov/pub/naif/generic_kernels/").getBytes());
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        }

        // Kernel cache does exist now. Read it in.
        try (var scanner = new Scanner(cfg.toFile());) {
            scanner.useDelimiter(",");
            while (scanner.hasNext()) {
                String prefix = scanner.next().trim(), url = scanner.next().trim();
                LOG.log(Level.INFO, "{0}, {1}", new String[]{prefix, url});

                DefaultTableModel tm = (DefaultTableModel) kernelCacheTable.getModel();
                if (tm.getRowCount() == 0) {
                    // We haven't loaded anything yet. Do it now.
                    tm.addRow(new Object[]{prefix, url});
                }
                kernelCacheTable.setModel(tm);
            }
            scanner.close();
        } catch (FileNotFoundException ex) {
            Exceptions.printStackTrace(ex);
        }

        // TODO read settings and initialize GUI
        // Example:
        // someCheckBox.setSelected(Preferences.userNodeForPackage(KernelCachePanel.class).getBoolean("someFlag", false));
        // or for org.openide.util with API spec. version >= 7.4:
        // someCheckBox.setSelected(NbPreferences.forModule(KernelCachePanel.class).getBoolean("someFlag", false));
        // or:
        // someTextField.setText(SomeSystemOption.getDefault().getSomeStringProperty());
    }

    void store() {
        LOG.log(Level.INFO, "store");
        // TODO store modified settings
        // Example:
        // Preferences.userNodeForPackage(KernelCachePanel.class).putBoolean("someFlag", someCheckBox.isSelected());
        // or for org.openide.util with API spec. version >= 7.4:
        // NbPreferences.forModule(KernelCachePanel.class).putBoolean("someFlag", someCheckBox.isSelected());
        // or:
        // SomeSystemOption.getDefault().setSomeStringProperty(someTextField.getText());
    }

    boolean valid() {
        LOG.log(Level.INFO, "valid");
        // TODO check whether form is consistent and complete
        return true;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable kernelCacheTable;
    // End of variables declaration//GEN-END:variables
}
